<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>VDC - Rezervačný systém pre Fitko</title>
    <!-- Tailwind CSS -->
    <script src="https://cdn.tailwindcss.com"></script>
</head>

<body class="bg-gray-100 text-gray-800">
    <header class="bg-white shadow-sm py-4">
        <div class="mx-auto px-12">
            <h1 class="text-xl font-bold">VDC - Rezervačný systém pre Fitko</h1>
        </div>
    </header>

    <div class="w-screen mx-auto px-12 py-12">
        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4">Popis</h2>
            <p class="mb-4">Táto aplikácia na rezerváciu tréningových lekcií umožňuje užívateľom prezerávať a rezervovať rôzne typy tréningových lekcií. 
                Aplikácia taktiež obsahuje rozhranie pre trénerov, ktorý môžu vytvárať nové lekcie pre klientov.
                Backend aplikácie je napísaný ako REST API v jazyku PHP a využíva databázu MySQL (MariaDB) na ukladanie informácií o lekciách, užívateľoch a rezerváciách.
                REST API je zabepečené pomocou JWT autorizácie. Každý požiadavok okrem prihlásenia registrácie, musí obsahovať parameter s názvom jwt_token,
                a jeho hodnota bude validný JWT token. JWT token sa na strane klienta ukláda v localstorage.
            </p>
            <p class="mb-4">
                Frontend aplikácie je vyvinutý pomocou Vue.js. Vue.js je reaktivný javascriptový framework, ktorý umožňuje dynamické a responzívne užívateľské rozhranie. 
                Vďaka Vue.js môžu užívatelia prezerávať a rezervovať lekcie bez nutnosti znovunačítavania stránok.
                Frontend aplikácie taktiež využíva CSS framework Tailwind.
            </p>  
            <div class="bg-blue-100 border-t border-b border-blue-500 text-blue-700 px-4 py-3" role="alert">
                <p class="font-bold">Dôležite info</p>
                <p class="text-sm">Z dôvodu, že aktuálny apache server, nepodporuje vlastný typ hlavičky (Header) http požiadavku, sa JWT token presunul v metóde GET ako posledný parameter cesty. 
                    V prípade POST metódy sa JWT token posiela dátovej časti požiadavku.</p>
                <p class="text-sm">Aktuálny server taktiež nepodporuje REST API metódy DELETE, PUT, a pod. Endpointy sú napísane a testované len lokálne, takže nerúčim za fungovanie :). Snáď to nebude mať veľký vplyv na výsledne hodnotie.</p>
              </div>     
        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4">Prihlasovacie údaje</h2>
            <p class="mb-4">Pri návrhnu aplikácie sa počítalo, že priradzovanie rolí bude môcť len Admin. Bohužiaľ s časovej núdze sa nestíhal vytvoriť admin panel, kde by to bude možné, tak priradzovcanie rolí je možne len priamou úpravov databázy.
                <ul class="list-disc ml-6">
                    <li>Klient 1 email: karel.capek@gmail.com, heslo: heslo454</li>
                    <li>Klient 2 email: uhorka.zelena@gmail.com, heslo: salat123</li>
                    <li>Trenér 1 email: harry.potter@bradavice.com, heslo: magia123</li>
                    <li>Trenér 2 email: julius.satisnky@gmail.com, heslo: slovensko789</li>
                </ul>
            </p>
        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4"><a href="http://mrkev.fme.vutbr.cz/~m217372/projekt/index.html" target="_blank" ="hover:text-blue-400">Odkaz na aplikáciu</a></h2>
        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4">Funkcie</h2>
            <ul class="list-disc ml-6">
                <li>Aplikácia poskytuje API endpointy k databáze</li>
                <li>Bezpečná autentifikácia (prihlásenie a registrácia).</li>
                <li>Klient - prezeranie starých a budúcich lekcií</li>
                <li>Klient - prezeranie prezeranie,tvorba a mazanie rezervácie na lekciu</li>
                <li>Trenér - prezeranie, tvorba a mazanie svojich lekcií</li>
            </ul>
        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4">ERD Diagram</h2>
            <figure>
                <img src="erd.png" alt="" class="mx-auto"/>
              </figure>
        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4">API Endpoints</h2>
            

<div class="relative overflow-x-auto">
    <table class="w-full text-sm text-left rtl:text-right text-gray-500 dark:text-gray-400">
        <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
            <tr>
                <th scope="col" class="px-6 py-3">
                    Meno
                </th>
                <th scope="col" class="px-6 py-3">
                    Metóda
                </th>
                <th scope="col" class="px-6 py-3">
                    URL
                </th>
                <th scope="col" class="px-6 py-3">
                    Parametry
                </th>
                <th scope="col" class="px-6 py-3">
                    Popis
                </th>
            </tr>
        </thead>
        <tbody>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Všetky dostupné lekcie
                </th>
                <td class="px-6 py-4">
                    GET
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/lections/:room_id/:date/:jwt_token
                </td>
                <td class="px-6 py-4">
                    username,room_id,date,jwt_token
                </td>
                <td class="px-6 py-4">
                    Získanie všetkých dostupných lekcií na ktoré sa môže klient rezervovať. Filtrované podľa dátumu a miestnosti.
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Všetky typy lekcií
                </th>
                <td class="px-6 py-4">
                    GET
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/lections/lection_types
                </td>
                <td class="px-6 py-4">
                    jwt_token
                </td>
                <td class="px-6 py-4">
                    Získanie všetkých typov lekcií, ktoré môže tréner vytvoriť.
                </td>
            </tr>
            
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Všetky lekcie trenéra
                </th>
                <td class="px-6 py-4">
                    GET
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/lections/:jwt_token
                </td>
                <td class="px-6 py-4">
                    username, jwt_token
                </td>
                <td class="px-6 py-4">
                    Získanie všetkých lekcií daného trenéra
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Všetky typy lekcií
                </th>
                <td class="px-6 py-4">
                    GET
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/lection_types/:jwt_token
                </td>
                <td class="px-6 py-4">
                    jwt_token
                </td>
                <td class="px-6 py-4">
                    Všetky typy lekcií, ktoré môže prihlasený tréner vytvoriť.
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Nová lekcia
                </th>
                <td class="px-6 py-4">
                    POST
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/lections
                </td>
                <td class="px-6 py-4">
                    username, params :{jwt_token,username,room_id,type,start_time,end_time}
                </td>
                <td class="px-6 py-4">
                    Tréner si môže vytvoriť svoju novú lekciu s miestnosťou a dátumom
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Odstránenie lekcie
                </th>
                <td class="px-6 py-4">
                    DELETE
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/lections/:lection_id/:jwt_token
                </td>
                <td class="px-6 py-4">
                    username,lection_id,jwt_token
                </td>
                <td class="px-6 py-4">
                    Tréner si môže odstrániť svoju lekciu
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Všetky rezervácie klienta
                </th>
                <td class="px-6 py-4">
                    GET
                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/reservations/:jwt_token
                </td>
                <td class="px-6 py-4">
                    username, jwt_token
                </td>
                <td class="px-6 py-4">
                    Klient môže získať všetky svoje rezervácie
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Vytvorenie novej rezervácie
                </th>
                <td class="px-6 py-4">
                    POST                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/reservations
                </td>
                <td class="px-6 py-4">
                    username, params :{jwt_token,lection_id}
                </td>
                <td class="px-6 py-4">
                    Klient môže vytvroriť novú rezervácie na určitú lekciu
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Odstránenie rezervácie
                </th>
                <td class="px-6 py-4">
                    DELETE                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/:username/reservations/:reservation_id/:jwt_token
                </td>
                <td class="px-6 py-4">
                    username, reservation_id, jwt_token
                </td>
                <td class="px-6 py-4">
                    Klient môže odstrániť rezerváciu na určitú lekciu
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Všetky miestnosti
                </th>
                <td class="px-6 py-4">
                    GET                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/rooms/:jwt_token
                </td>
                <td class="px-6 py-4">
                    jwt_token
                </td>
                <td class="px-6 py-4">
                    Získanie všetkých tréningových miestnosti
                </td>
            </tr>
            <tr class="bg-white border-b dark:bg-gray-800 dark:border-gray-700">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Prihlásenie
                </th>
                <td class="px-6 py-4">
                    POST                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/login
                </td>
                <td class="px-6 py-4">
                    params:{email,password}
                </td>
                <td class="px-6 py-4">
                    Prihlásenie uživateľa do aplikácie
                </td>
            </tr>
           
            <tr class="bg-white dark:bg-gray-800">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 whitespace-nowrap dark:text-white">
                    Registrácia
                </th>
                <td class="px-6 py-4">
                    POST                </td>
                <td class="px-6 py-4">
                    /~m217372/projekt/backend/index.php/register
                </td>
                <td class="px-6 py-4">
                    params:{username,email,password}
                </td>
                <td class="px-6 py-4">
                    Registrácia uživateľa do aplikácie
                </td>
            </tr>
            
            
        </tbody>
    </table>
</div>

        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4 ">Súbory na stiahnutie</h2>
            
                <p><a class="hover:text-blue-400 font-semibold " target="_blank" href="erd.png" download>ERD Diagram</a></li></p>
                <p><a class="hover:text-blue-400 font-semibold " target="_blank" href="init.sql"  download>SQL skript</a></li></p>
                <p><a class="hover:text-blue-400 font-semibold " target="_blank" href="https://gitlab.com/jan.ksenak/vdc_reservation_system">Gitlab repozitár</a></li></p>
           
        </section>

        <section class="mb-4">
            <h2 class="text-lg font-bold mb-4">Použité Technológie</h2>
            <ul class="list-disc ml-6">
                <li>HTML</li>
                <li><a class="hover:text-blue-400" target="_blank" href="https://tailwindcss.com/">Tailwind</a></li>
                <li><a class="hover:text-blue-400" target="_blank" href="https://vuejs.org/">Vue JS</a></li>
                <li>PHP 7.2.26</a></li>
                <li>MySQL (MariaDB 10.4.11)</li>
            </ul>
        </section>

        <section>
            <h2 class="text-lg font-bold mb-4">Inštalácia</h2>
            <ol class="list-decimal ml-6">
                <li>Stiahnite si tento repozitár => 
                    <a class="hover:text-blue-400" target="_blank" href="https://gitlab.com/jan.ksenak/vdc_reservation_system">VDC Projekt</a>
                </li>
                <li>Inštálacia potrebných knižníc
                   
                    <div class="bg-slate-300 py-1 px-4 rounded-md my-2">
                        <pre><code class="font-semibold">npm install</code></pre>
                    </div>
                   
                </li>
                <li>Spustenie developerského prostredia
                    
                    <div class="bg-slate-300 py-1 px-4 rounded-md my-2">
                        <pre><code class="font-semibold">npm run dev</code></pre>
                    </div>
                    
                </li>
                <li>Vytvenie produkčnej verzie
                    <div class="bg-slate-300 py-1 px-4 rounded-md my-2">
                        <pre><code class="font-semibold">npm run build</code></pre>
                    </div>
                </li>
            </ol>
        </section>


    
    </div>
</body>

</html>
